      SUBROUTINE SCAN(IVAL)
C   
C   
C     THIS ROUTINE SCANS A SUBSTITUTION FIELD FOR A DEF NAME OR AN FF
C     DIRECTIVE.  THE FIELD TYPE AND LENGTH ARE DETERMINED.
C   
C   
C     ENTRY PARAMETERS
C        ICOL - POINTS TO COLUMN THAT SCAN STARTS IN
C     EXIT PARAMETERS 
C        ICOL - POINTS TO COLUMN THAT SCAN ENDED ON 
C        IVAL - VALUE OF FIELD IF FIELD IS A CONSTANT 
C        ILEN - LENGTH OF FIELD 
C        JATT - ARRAY SPECIFING FIELD ATTRIBUTES
C        FTYPE - FIELD TYPE 
C           2 = C, CONSTANT FIELD 
C           1 = X, DONT CARE FIELD
C           2 = C, CONSTANT FIELD 
C           3 = NULL FIELD
C           4 = NEW FORMAT NAME 
C           5 = NO VALID FIELDS OR FORMAT NAMES LEFT
C        IERR - ERROR INDICATOR 
C           1 = NO ERROR
C           2 = ILLEGAL FIELD TYPE
C           3 = ILLEGAL CHARACTER
C           4 = UNDEFINED SYMBOL
C           5 = ILLEGAL FIELD LENGTH
C           6 = FIELD LENGTH CONFLICT 
C           7 = VALUE ERROR, VALUE TOO LARGE
C           8 = ATTRIBUTE ERROR 
C           9 = ARGUMENT ERROR
C          10 = EXPRESSION ERROR
C          11 = ILLEGAL NEGATIVE VALUE
C          12 = ILLEGAL CONSTANT MODIFIER 
C          13 = ADDRESS NOT ON CURRENT PAGE 
C 
      REAL IVAL
      DIMENSION NUMS(16),ITERM(4)
      DIMENSION JCVAL(4)
      INTEGER FTYPE,FLEN
      REAL ITABV(384),LC,LODLC,LCMAX
      COMMON ICRD,IPRT,IPCH,MCFLE,IMFLE,IDFLE,MCREC,IMREC,IDREC,IOREC
      COMMON MLAB,MOPC,IBIT,ICCNT,IWORD,IERRL,IERRI,IEND,LEND,IFRMC
      COMMON LSOR,LIF,LSYM,LREF,LDEF,LOCT,LOBJ,LOBJ1,LOBJ2,LINV
      COMMON ILEN,KLEN,LLEN,FLEN,KWORD,IYFLD,IZFLD
      COMMON IDUP,NDUP,NFLAG,IOFLG,LWORD,LINEL,KFILE
      COMMON IFBIT,ZVAL,CVAL,JREAD,IN(80),INB(80),LINE,IPAGE,LISN
      COMMON IALPH(37),IAST,IDOLR,ISHRP,IAMP,ICOLN
      COMMON IBLNK,ICTAB,ISEMI,ICOMM,IPLUS,IMIN,IMULT,IDIV
      COMMON IRPAR,ILPAR,IATT(9),JATT(5),LATT(9),IFPAR(16),NBASE,JBASE
      COMMON ICOL,IFCOL,MCOL,MLCOL,IOLIN,ICNT,LTITL(50),IADDR(4,12)
      COMMON ITYPE,JTYPE,FTYPE,IERR,IERRS,IOPVA,JCOL,IBUG,IOVER
      COMMON IPASS,LC,IOBIN(128),IPDEF,LODLC,LCMAX,LCMIN,LEN
      COMMON ITAB(4,384),ITABS(384),ITABV,NAME(4),INDEX,INDET
      COMMON ISYM,LTAB,IFORM,ITRUN,ILOUT,IXCOL,NUMER,ITRMI,ITRMO
      COMMON IXTAB(768),MXREF,IXT,IXPNT,IXCNT,IXPAG,MCORE(128)
C
C
C	THE NAMED COMMON VARIABLE IFLD(400) IS A DUMMY ENTRY POINT FOR
C	A MUCH LARGER ARRAY -- DEFINED IN INIT.FOR. 
C
      COMMON /OVRLAY/IFLD(400)
C
      EQUIVALENCE (NUMS(1),IALPH(1))
      EQUIVALENCE (ICHRV,IALPH(32)),(ICHRX,IALPH(34))
      EQUIVALENCE(ITERM(1),IBLNK)
      DATA JCVAL(1),JCVAL(2),JCVAL(3),JCVAL(4) /2,8,16,10/
C   
      IVAL = 0.
      FTYPE = 0
      ILEN = -1
C     SCAN TO NON-BLANK CHARACTER
60    IF(ICOL-MCOL) 65,65,75
65    IF(IN(ICOL)-IBLNK) 66,70,66
66    IF(IN(ICOL)-ICTAB) 72,70,72
70    ICOL = ICOL+1
      GO TO 60
C     CHECK FOR A COMMENT LINE
72    IF(IN(ICOL)-ISEMI) 115,75,115
C     READ NEXT LINE, CHECK FOR CONTINUATION
75    IF(JREAD.EQ.1) GO TO 78
77    CALL INOUT(1)
78    LCOL = IFCOL
C     SCAN TO FIRST NON-BLANK CHARACTER
80    IF(LCOL-MCOL) 85,85,945
85    IF(INB(LCOL)-IBLNK) 86,87,86
86    IF(INB(LCOL)-ICTAB) 90,87,90
87    LCOL = LCOL+1
      GO TO 80
90    IF(INB(LCOL)-IDIV) 110,92,110
92    IF(IDUP.EQ.0) GO TO 921
      IDUP = 0
      NDUP = 0
      GO TO 945
921   LEN = 0
      CALL LOUT(1)
      LEN = 1 
C     INCREMENT LINE NUMBER 
      LISN = LISN+1 
C     MOVE NEW LINE TO INPUT BUFFER 
      DO 93 I=1,80
      IN(I) = INB(I)
93    CONTINUE
      ICOL = LCOL+1 
      IXCOL = IFCOL 
C     SCAN TO FIRST NON-BLANK CHARACTER 
      GO TO 60
110   JREAD = 1 
      FTYPE = 5 
      LEND = 1
C     CHECK FOR OVERLAY INDICATOR 
      IF(IOVER) 945,990,945 
115   IF(IOVER) 900,120,900 
C 
C     DETERMINE FIELD TYPE
C 
120   LCOL = ICOL 
C     CHECK FOR A DECIMAL NUMBER INDICATING FIELD LENGTH
      DO 125 I=1,10 
      IF(IN(ICOL)-NUMS(I)) 125,130,125
125   CONTINUE
      GO TO 160 
130   ILEN = 0
C     CONVERT FIELD LENGTH TO BINARY
151   DO 152 I=1,10 
      IF(IN(ICOL)-NUMS(I)) 152,155,152
152   CONTINUE
      GO TO 156 
155   ILEN = ILEN*10+I-1
      ICOL = ICOL+1 
      GO TO 151 
C     CHECK FOR A DON"T CARE FIELD                           -- X 
156   IF(IN(ICOL)-ICHRX) 1585,157,1585
157   ICOL = ICOL+1 
      DO 158 I=1,4
      IF(IN(ICOL)-ITERM(I)) 158,159,158 
158   CONTINUE
      ICOL = LCOL 
      GO TO 230 
1585  IF(IN(ICOL)-ILPAR) 1587,230,1587
1587  ICOL = LCOL 
      ILEN = -1 
      GO TO 160 
159   FTYPE = 1 
      GO TO 900 
C     CHECK FOR NULL FIELD                                   -- NULL
160   IF(IN(ICOL)-ICOMM) 210,200,210
200   FTYPE = 3 
      GO TO 900 
C     CHECK FOR FORMAT OVERLAY INDICATOR                     -- & 
210   IF(IN(ICOL)-IAMP) 230,220,230 
220   FTYPE = 4 
      IOVER = 1 
      ICOL = ICOL+1 
      GO TO 60
C     CHECK FOR A NUMBER, LABEL, OR EXPRESSION
230   CALL ESCAN(IVAL)
      GO TO (400,945,920,950,935,930,955,960,965),IERR
C 
C     SET FIELD TYPE TO CONSTANT                             -- C 
400   FTYPE = 2 
C 
C     PERFORM ACTIONS ON CONSTANT INDICATED BY
C     FIELD ATTRIBUTES SPECIFIED IN DEFINITION PROGRAM
C 
      CALL MODFY(IVAL,FLEN,0) 
      IF(IERR-1) 965,500,965
C     CHECK TO SEE IF FIELD LENGTH HAS BEEN SPECIFIED 
500   IF(ILEN) 510,520,520
510   ILEN = KLEN 
C     CHECK TO SEE IF ACTUAL FIELD LENGTH EQUALS SPECIFIED FIELD LENGTH 
520   IF(ILEN-KLEN) 930,550,930 
C     SEE IF FIELD LENGTH EXCEEDS MAXIMUM ALLOWABLE 
550   IF(ILEN-IFBIT) 800,800,925
C     CHECK TO SEE IF FIELD LENGTH EXCEEDS WORD LENGTH
800   IF(ILEN-KWORD) 802,802,925
C     CHECK FOR CORRECT TERMINATION CHARACTER 
802   DO 810 I=1,4
      IF(IN(ICOL)-ITERM(I)) 810,900,810 
810   CONTINUE
      GO TO 915 
C 
C     VALID FIELD FOUND 
C 
900   IERR = 1
      GO TO 990 
C 
C     SCAN ERRORS 
C 
C     ILLEGAL FIELD TYPE
910   IERR = 2
      GO TO 990 
C     ILLEGAL CHARACTER 
915   IERR = 3
      GO TO 990 
C     UNDEFINED SYMBOL
920   IERR = 4
      GO TO 990 
C     FIELD LENGTH TOO LARGE
925   IERR = 5
      GO TO 990 
C     FIELD LENGTH CONFLICT 
930   IERR = 6
      GO TO 990 
C     VALUE ERROR 
935   IERR = 7
      GO TO 990 
C     FIELD OR CONSTANT ATTRIBUTE ERROR 
940   IERR = 8
      GO TO 990 
C     ARGUMENT ERROR IN FIELD 
945   IERR = 9
      ICOL = ICOL+1 
      GO TO 990 
C     EXPRESSION ERROR IN FIELD 
950   IERR = 10 
      GO TO 990 
C     VALUE IS NEGATIVE, ILLEGAL
955   IERR = 11 
      GO TO 990 
C     ILLEGAL CONSTANT MODIFIER 
960   IERR = 12 
      GO TO 990 
C     ADDRESS NOT ON CURRENT PAGE 
965   IERR = 13 
990   CONTINUE
C
C	DEBUG CODE--NOT NEEDED FOR OPERATION
C
C      IF(IBUG.EQ.0) GO TO 9999
C      WRITE(IPRT,9998) FTYPE,ILEN,KLEN,ICOL,IERR,IVAL 
C9998  FORMAT(' SCAN',5(1X,I5),F12.1)
9999  RETURN
      END 
998) FTYPE,ILEN,KLEN,ICOL,IERR,IVAL 
C9998  FORMAT(' SCAN',5(1X,I5),F12.1)
9999  RETURN
      END 
